#!/bin/sh -ex

version=`grep Version: *spec | sed -e 's/Version:\s*\(.*\)/\1/'`
echo ${version}

git clone https://github.com/aalmiray/Json-lib.git json-lib-${version}
pushd json-lib-${version}
# Release 2.4
# https://github.com/aalmiray/Json-lib/commit/a45916508dcfe4fe048e2eac10573a4a20ed6a9a
git reset --hard a45916508dcfe4fe048e2eac10573a4a20ed6a9a
git archive -v --prefix=json-lib-${version}/ HEAD | xz > ../json-lib-${version}.tar.xz

# development branch (contains changes from jenkins upstream)
git checkout development
# Merge changes coming from jenckinsci/rebase-2.4
git reset --hard 78cc0083692ad2e30c7bcf3929c697d605a90317
git archive -v --prefix=jenkins-json-lib-${version}/ HEAD | xz > ../jenkins-json-lib-${version}.tar.xz
popd
rm -Rf json-lib-${version}

